︠9e2e3ae3-8a6a-4c45-9565-f08570aded63︠
# EXPONENTIAL GROWTH: CONTINUOUS MODEL

def exponential(N, r, x):
    return N * e**(r * x)

plot(exponential(100., 0.25, x),(0,10))
︡51c1a2e9-10e2-4bad-b02f-d476bad05cde︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠f7200625-1ea6-4128-8775-d4a96482647d︠
plot(exponential(100., 0.25, x),(0,10), color = "blue") + plot(exponential(100., 0.15, x),(0,10), color = "red") + plot(exponential(100., 0.05, x),(0,10), color = "orange") + plot(exponential(100., -0.15, x),(0,10), color = "green")
︡c37ea109-50fb-4114-aa6c-4d337ebc868d︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠73229b53-2b3f-40e6-9dd7-ca023fa1bcc5︠
# EXPONENTIAL GROWTH: DISCRETE MODEL

def discrete_exp(N, lam):
    return N * lam

n0 = 100
time = 100
pop_sizes = [n0]

for years in range(1,time): 
    pop_sizes.append(discrete_exp(pop_sizes[-1], 1.05))

plot_data = []
for years in range(len(pop_sizes)):
    plot_data.append([years, pop_sizes[years]])

points(plot_data)
︡4d8af314-6baf-4f38-b960-8c0f8f86574f︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠ec2e2c0c-cdb8-4681-8518-ecf74966d1b0︠
line(plot_data)
︡8b97a931-ce73-4259-88cf-51177a3a8b31︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠7c6e37ae-903d-465c-8d89-ce82bdf9fd7b︠
line(plot_data, marker=".")
︡2a86db87-ba34-4c9f-95b4-bfff305b866d︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠6c8c2ea0-f98b-47ec-9e9a-a65e0413f5da︠
# EXPONENTIAL GROWTH: DISCRETE w/STOCHASTICITY

def discrete_exp(N, lam, mu, sd):
    return N * (lam + gauss(mu, sd))

n0 = 100
time = 100
lam = 1.05
pop_sizes = [n0]
mu = 0.
sd = 0.25

for years in range(1,time): 
    pop_sizes.append(discrete_exp(pop_sizes[-1], lam, mu, sd))

plot_data = []
for years in range(len(pop_sizes)):
    plot_data.append([years, pop_sizes[years]])

line(plot_data, marker = ".")
︡6fcd9c7b-bd07-4d3f-8e7e-f0022fababd4︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠4a2c579b-7753-488d-8394-bf3f6eb1e640︠
# LOGISTIC GROWTH: CONTINUOUS MODEL

def log_growth(N0, K, r, t):
    return K/(1.+((K-N0)/N0)*exp(-r*t))
    
plot(log_growth(50, 250, 0.2, x), (0, 100), color = "blue") + plot(log_growth(400, 250, 0.2, x), (0, 100), color = "red")
︡e41c27eb-1b5d-4e4d-99fd-343a981f40c5︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠25165e85-bb27-4ef8-bf99-b7c309b54249︠
# LOGISTIC GROWTH: DISCRETE MODEL

def disc_log_growth(N, K, r):
    return N + N * r * (1 - N/K)

time = 100
r = 2.58
K = 500
n0 = 20
pop_sizes = [n0]

for years in range(1,time): 
    pop_sizes.append(disc_log_growth(pop_sizes[-1], K, r))

plot_data = []
for years in range(len(pop_sizes)):
    plot_data.append([years, pop_sizes[years]])

line(plot_data, marker = '.')
︡39e03345-43a1-417a-9ad1-c8ff7b451f6c︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠8977429b-5090-460e-813c-c72b6cd1045a︠
time_lag = []
for years in range(len(pop_sizes)-1):
    time_lag.append([pop_sizes[years], pop_sizes[years+1]])
    
points(time_lag)
︡0665b053-4e97-4de5-a508-dcaa32da88e7︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
